package com.parksong.basics.beans;

import com.parksong.basics.util.constants.ReturnStatusCodeConstants;
import lombok.Data;

import java.io.Serializable;

/**
 * @ClassName PageResultBean
 * @Description 用于返回分页
 * @Author kael
 * @Date 2019/9/6 0006 下午 13:56
 * @Version 1.0
 **/
@Data
public class PageResultBean <T> implements Serializable {

    private static final long serialVersionUID = 1L;

    private String msg = "请求成功";

    private int code = ReturnStatusCodeConstants.SUCCESS;

    private T data;

    private String requestSign;

    /**
     * 当前页
     */
    private Integer currentPage=1;
    /**
     * 每页条数
     */
    private Integer pageSize=10;
    /**
     * 总条数
     */
    private Long total;

    public PageResultBean() {
        super();
    }

    public PageResultBean(T data) {
        super();
        this.data = data;
    }

    public PageResultBean(T data,Long total) {
        super();
        this.data = data;
        this.total = total;
    }

    public PageResultBean(Throwable e) {
        super();
        this.msg = e.toString();
        this.code = ReturnStatusCodeConstants.FAIL;
    }
}
