package com.parksong.basics.beans;

import com.parksong.basics.util.constants.ReturnStatusCodeConstants;
import lombok.Data;

import java.io.Serializable;

/**
 * @author LiuJS
 * @Time 2021/7/8 10:03
 * @Desc
 * @Version 1.0
 */
@Data
public class PageResultNo <T> implements Serializable {
    private static final long serialVersionUID = 1L;

    private String msg = "请求成功";

    private int code = ReturnStatusCodeConstants.SUCCESS;

    private T data;

    private String requestSign;

    /**
     * 当前页
     */
    private Integer currentPage=1;
    /**
     * 每页条数
     */
    private Integer pageSize=10;
    /**
     * 总条数
     */
    private Long total;

    public PageResultNo() {
        super();
    }

    public PageResultNo(T data) {
        super();
        this.data = data;
    }

    public PageResultNo(T data,Long total) {
        super();
        this.data = data;
        this.total = total;
    }

    public PageResultNo(Throwable e) {
        super();
        this.msg = e.toString();
        this.code = ReturnStatusCodeConstants.FAIL;
    }
}
