package com.parksong.basics.beans;

import com.parksong.basics.util.constants.ReturnStatusCodeConstants;
import lombok.Data;

import java.io.Serializable;

/**
 * @ClassName ResultBean
 * @Description 统一数据返回bean，分页除外
 * @Author kael
 * @Date 2019/6/27 0027 上午 11:22
 * @Version 1.0
 **/
@Data
public class ResultBean<T> implements Serializable {

    private static final long serialVersionUID = 1L;


    private String msg = "请求成功";

    private int code = ReturnStatusCodeConstants.SUCCESS;

    private T data;

    private String requestSign;

    public ResultBean() {
        super();
    }

    public ResultBean(T data) {
        super();
        this.data = data;
    }

    public ResultBean(Throwable e) {
        super();
        this.msg = e.toString();
        this.code = ReturnStatusCodeConstants.FAIL;
    }
}
