package com.parksong.basics.dao;

import com.parksong.basics.filter.Filter;

import java.util.Collection;
import java.util.List;

/**
 * 基础dao层
 *
 * @author kael
 */
public interface BasicDao<J extends Filter,T> {
    int insert(T entity);

    int deleteById(Integer id);

    int deleteBatchIds(Collection<? extends Number> idList);

    int updateById(Integer id);

    int update(T entity);

    T getById(Integer id);

    List<T> selectBatchIds(Collection<? extends Number> idList);

    Long selectCount(J filter);

    List<T> selectList(J filter);

    List<T> all();
}
