/**
 * @FileName: BaseException.java
 * @Package cn.haliaeetus.framework.base.exception
 * 
 * @author warship
 * @created 2013年11月22日 下午3:56:00
 * 
 * Copyright 2013-2050 佰颂物联 版权所有
 */
package com.parksong.basics.exception;

/**
 * <p>异常基类</p>
 * 
 * @author warship
 * @since 1.0
 * @version 1.0
 */
public abstract class BaseException extends RuntimeException {
	
	private static final long serialVersionUID = 4061837650459227967L;

	/**
	 * 构造器
	 * 
	 */
	public BaseException() {
		super();
	}

	/**
	 * 构造器
	 * 
	 * @param message	异常详细信息
	 * @param cause	异常原因
	 */
	public BaseException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
	 * 构造器
	 * 
	 * @param message	异常详细信息
	 */
	public BaseException(String message) {
		super(message);
	}

	/**
	 * 构造器
	 * 
	 * @param cause	异常原因
	 */
	public BaseException(Throwable cause) {
		super(cause);
	}

}
