package com.parksong.basics.filter;

import com.parksong.beans.express.ExpressDept;
import com.parksong.beans.user.User;
import lombok.Data;
import org.apache.logging.log4j.util.Strings;

/**
 * @ClassName Filter
 * @Description TODO
 * @Author kael
 * @Date 2019/9/6 0006 下午 14:44
 * @Version 1.0
 **/
@Data
public class Filter {

    private static final int MAX_PAGENUMBER = 100;
    private static final int MIN_PAGENUMBER = 1;
    private static final int MIN_PAGE = 1;
    /**
     * 排序字段
     */
    private String sort;
    /**
     * 排序方式
     */
    private String sortType;
    /**
     * 需要查询的页数
     */
    private Integer currentPage;
    /**
     * 每页条数
     */
    private Integer pageSize;
    /**
     * 数据库中的偏移条数
     */
    private Long count;
    /**
     * 拼接的sql语句，不建议使用，如果一定要使用请将该字段放在sql查询条件最后面，并且需要做sql注入验证
     */
    private String subSql;
    /**
     * 登录后的用户信息
     */
    private User user;
    /**
     * 登录后微信小程序用户信息
     */
    private ExpressDept expressDept;
    /**
     * 门店Id
     */
    private Integer storeId;
    /**
     * 客户端类型（默认1），1：app，2：web
     */
    private Integer clientType = 1;

    private String requestSign;

    /**
     * 需要初始化的数据
     */
    public Filter init(){
        if(pageSize!=null){
            if(pageSize.compareTo(MAX_PAGENUMBER)>0){
                this.pageSize = MAX_PAGENUMBER;
            }
            if(pageSize.compareTo(MIN_PAGENUMBER)<0){
                this.pageSize = MIN_PAGENUMBER;
            }
        }else{
            this.pageSize = 10;
        }
        if(currentPage == null || currentPage.compareTo(MIN_PAGE)<0){
            this.currentPage = MIN_PAGE;
        }
        this.count = new Long((this.currentPage-1) * this.pageSize);
        if(user!=null){
            this.storeId = user.getStoreId();
        }
        return this;
    }

    public Filter sortInit(){
        if(Strings.isBlank(sort)){
            this.sort = "createTime";
        }
        if(Strings.isBlank(sortType)){
            this.sortType = "desc";
        }
        return this;
    }
}
