package com.parksong.basics.services;

import com.parksong.basics.beans.StoreReqLimit;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.services.store.ConfigurationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName BasicsService
 * @Description TODO
 * @Author kael
 * @Date 2019/9/9 0009 上午 11:01
 * @Version 1.0
 **/
@Service
public class BasicsService {

    @Autowired
    private ConfigurationService configurationService;

    public StoreReqLimit getStoreReqLimitByUserId(String storeId) {

        CacheTool cacheTool = CacheTool.initLimit();
        StoreReqLimit storeReqLimit = (StoreReqLimit) cacheTool.getBean(storeId);
        if (storeReqLimit != null) {
            storeReqLimit.setSumCount(storeReqLimit.getSumCount()+1);
            if((System.currentTimeMillis()-storeReqLimit.getTime())<Integer.parseInt(configurationService.getConfigurationByCode("limtStoreReqTime").getOValue1())){
                storeReqLimit.setCount(storeReqLimit.getCount()+1);
                if(storeReqLimit.getCount()>=Integer.parseInt(configurationService.getConfigurationByCode("limtStoreReqCount").getOValue1())){
                    storeReqLimit.setIsLimitFlag(true);
                }
            }else{
                storeReqLimit.setIsLimitFlag(false);
                storeReqLimit.setTime(System.currentTimeMillis());
                storeReqLimit.setCount(1);
            }
            cacheTool.saveBean(storeId, storeReqLimit);
            return storeReqLimit;
        } else {
            StoreReqLimit newSrl = new StoreReqLimit();
            newSrl.setStoreId(storeId);
            newSrl.setCount(1);
            newSrl.setSumCount(1);
            newSrl.setIsLimitFlag(false);
            newSrl.setTime(System.currentTimeMillis());
            cacheTool.saveBean(storeId, newSrl);
            return newSrl;
        }
    }
}
