package com.parksong.basics.services;

import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName RabbitService
 * @Description TODO
 * @Author kael
 * @Date 2019/9/11 0011 下午 17:23
 * @Version 1.0
 **/
@Service
@Slf4j
public class RabbitService {

    @Autowired
    private RabbitTemplate rabbitTemplate;

    /**
     * 发送消息
     * @param exchange
     * @param routingKey
     * @param info
     */
    public void send(String exchange, String routingKey, String info) {
        rabbitTemplate.convertAndSend(exchange, routingKey, info);
    }

    /**
     * 定时发送
     * @param queue
     * @param time
     * @param info
     */
    public void timingSend(String queue, Long time, final String info) {
        try {
            // rabbitTemplate.convertAndSend(queue,(Object)info, new MyMessagePostProcessor(time));
            rabbitTemplate.convertAndSend(queue,info, message -> {
                message.getMessageProperties().setHeader("delay", time);
                return message;
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 手机号同步
     * @param exchange
     * @param routingKey
     * @param info
     */
    public void phoneLibPush(String exchange,String routingKey, String info){
        rabbitTemplate.convertAndSend(exchange, routingKey, info);
    }

}
