package com.parksong.basics.util.basic;

import org.apache.tomcat.util.codec.binary.Base64;

import java.nio.charset.Charset;
import java.security.MessageDigest;

public class Md5Util {

	/** @return byte[16] */
	public static byte[] md5(byte[] bytes) {
		if (bytes == null) {
			throw new IllegalArgumentException();
		}
		try {
			MessageDigest digest = MessageDigest.getInstance("MD5");
			return digest.digest(bytes);
		} catch (Exception e) {
			return null;
		}
	}
	/** @return byte[16] */
	public static byte[] md5(String s) {
		return md5(toBytes(s));
	}
	/** @return String[32] */
	public static String md5AsUpperHex(String s) {
		return md5AsUpperHex(toBytes(s));
	}
	/** @return String[32] */
	public static String md5AsLowerHex(String s) {
		return md5AsLowerHex(toBytes(s));
	}
	/** @return String[32] */
	public static String md5AsUpperHex(byte[] bytes) {
		return asHex(md5(bytes), false);
	}
	/** @return String[32] */
	public static String md5AsLowerHex(byte[] bytes) {
		return asHex(md5(bytes), true);
	}

	/* ------------------------- impl ------------------------- */

	private static byte[] toBytes(String s) {
		return (s != null ? s : "").getBytes(Charset.forName("UTF-8"));
	}
	private static final char[] HEX_CHARS_LOWER = "0123456789abcdef".toCharArray();
	private static final char[] HEX_CHARS_UPPER = "0123456789ABCDEF".toCharArray();
	private static String asHex(byte[] bytes, boolean lowerCase) {
		if (bytes == null || bytes.length != 16) {
			throw new IllegalArgumentException();
		}

		char[] template = lowerCase ? HEX_CHARS_LOWER : HEX_CHARS_UPPER;
		char chars[] = new char[32];
		for (int i = 0; i < chars.length; i = i + 2) {
			byte b = bytes[i / 2];
			chars[i] = template[(b >>> 4) & 0xf];
			chars[i + 1] = template[b & 0xf];
		}
		return new String(chars);
	}

	public static String caiNiaoDoSign(String content, String charset, String keys) {
		String sign = "";
		content = content + keys;
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			md.update(content.getBytes(charset));
			sign = new String(Base64.encodeBase64(md.digest()), charset);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		return sign;
	}

	public static String MD5Encode(String origin, String charsetname) {
		String resultString = null;
		try {
			resultString = new String(origin);
			MessageDigest md = MessageDigest.getInstance("MD5");
			if (charsetname == null || "".equals(charsetname)) {
				resultString = byteArrayToHexString(md.digest(resultString
						.getBytes()));
			}
			else {
				resultString = byteArrayToHexString(md.digest(resultString
						.getBytes(charsetname)));
			}
		} catch (Exception exception) {
		}
		return resultString;
	}

	private static String byteArrayToHexString(byte b[]) {
		StringBuffer resultSb = new StringBuffer();
		for (int i = 0; i < b.length; i++) {
			resultSb.append(byteToHexString(b[i]));
		}
		return resultSb.toString();
	}

	private static String byteToHexString(byte b) {
		int n = b;
		if (n < 0) {
			n += 256;
		}
		int d1 = n / 16;
		int d2 = n % 16;
		return hexDigits[d1] + hexDigits[d2];
	}


	private static final String hexDigits[] = { "0", "1", "2", "3", "4", "5",
			"6", "7", "8", "9", "a", "b", "c", "d", "e", "f" };

}
