package com.parksong.basics.util.redis;

import org.springframework.beans.factory.annotation.Autowired;
import redis.clients.jedis.JedisCluster;

import java.util.Map;
import java.util.Set;

public class JedisClientClusterImpl implements JedisClient {

	@Autowired
	private JedisCluster jedisCluster;
	
	@Override
	public String get(String key) {
		return jedisCluster.get(key);
	}

	@Override
	public byte[] get(byte[] key) {
		return new byte[0];
	}

	@Override
	public String set(String key, String value) {
		return jedisCluster.set(key, value);
	}

	@Override
	public String set(String key, String value, int expire) {
		value = jedisCluster.set(key, value);
		if (expire != 0) {
			jedisCluster.expire(key, expire);
		}
		return value;
	}

	@Override
	public String set(byte[] key, byte[] value) {
		return null;
	}

	@Override
	public String set(byte[] key, byte[] value, int expire) {
		return null;
	}

	@Override
	public String hget(String hkey, String key) {
		return jedisCluster.hget(hkey, key);
	}

	@Override
	public long hset(String hkey, String key, String value) {
		return jedisCluster.hset(hkey, key, value);
	}

	@Override
	public long incr(String key) {
		return jedisCluster.incr(key);
	}

	@Override
	public long incrBy(String key, Integer num) {
		return jedisCluster.incrBy(key,num);
	}

	@Override
	public long expire(String key, int second) {
		return jedisCluster.expire(key, second);
	}

	@Override
	public long ttl(String key) {
		return jedisCluster.ttl(key);
	}

	@Override
	public long del(String key) {
		
		return jedisCluster.del(key);
	}

	@Override
	public long del(byte[] key) {
		return 0;
	}

	@Override
	public long hdel(String hkey, String key) {
		
		return jedisCluster.hdel(hkey, key);
	}

	@Override
	public Set<byte[]> keys(String pattern) {
		return null;
	}

	@Override
	public void flushDB() {

	}

	@Override
	public Long dbSize() {
		return null;
	}

	@Override
	public Long sadd(String key, String... members) {
		return jedisCluster.sadd(key, members);
	}

	@Override
	public Set<String> smembers(String key) {
		return jedisCluster.smembers(key);
	}

	@Override
	public Long srem(String key, String... members) {
		
		return jedisCluster.srem(key, members);
	}

	@Override
	public Set<String> sunion(String... keys) {
		
		return jedisCluster.sunion(keys);
	}

	@Override
	public Long sinter(String dstkey, String... keys) {
		
		return jedisCluster.sinterstore(dstkey, keys);
	}

	@Override
	public Set<String> sdiff(String... keys) {
		
		return jedisCluster.sdiff(keys);
	}

	@Override
	public Map<String,String> hgetall(String hkey) {
		return jedisCluster.hgetAll(hkey);

	}

}
