package com.parksong.beans.app;

import lombok.Data;

/**
 * @author LiuJS
 * @Time 2021/5/27 16:33
 * @Desc
 * @Version 1.0
 */
@Data
public class AppDataBean {
    /**
     * 蒲公英生成的用于区分历史版本的build号
     */
    private Integer buildBuildVersion;
    /**
     * 强制更新版本号（未设置强置更新默认为空）
     */
    private String forceUpdateVersion;
    /**
     * 强制更新的版本编号
     */
    private String forceUpdateVersionNo;
    /**
     * 是否强制更新
     */
    private Boolean needForceUpdate;
    /**
     * 应用安装地址
     */
    private String downloadURL;
    /**
     * 是否有新版本
     */
    private Boolean buildHaveNewVersion;
    /**
     * 上传包的版本编号，默认为1 (即编译的版本号，一般来说，编译一次会变动一次这个版本号, 在 Android 上叫 Version Code。对于 iOS 来说，是字符串类型；对于 Android 来说是一个整数。例如：1001，28等。)
     */
    private String buildVersionNo;
    /**
     * 版本号, 默认为1.0 (是应用向用户宣传时候用到的标识，例如：1.1、8.2.1等。)
     */
    private String buildVersion;
    /**
     * 应用短链接
     */
    private String buildShortcutUrl;
    /**
     * 应用更新说明
     */
    private String buildUpdateDescription;
}
