package com.parksong.beans.log;

import com.parksong.basics.beans.BasicsBean;
import lombok.Builder;
import lombok.Data;

/**
 * @ClassName LoggingEvent
 * @Description 日志类，本应该单独使用一个项目
 * @Author kael
 * @Date 2019/9/10 0010 下午 14:43
 * @Version 1.0
 **/
@Data
@Builder
public class LoggingEvent extends BasicsBean {

    /**
     * 接口传入参数
     */
    private String requestMsg;
    /**
     * 接口传出参数
     */
    private String responseMsg;
    /**
     * 用户id
     */
    private String userId;
    /**
     * 门店Id
     */
    private Integer storeId;
    /**
     * 返回码，除0以外全部算失败
     */
    private Integer returnCode;
    /**
     * 日志类型，1为app接口日志
     */
    private String type;
    /**
     * 执行时间，单位毫秒
     */
    private Integer exTime;
    /**
     * 备用字段
     */
    private String spare1;
    private String spare2;
    private String spare3;

}
