package com.parksong.beans.message;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * 通告<br>
 *
 * @className: TempNotice
 * @author: liujs
 * @date: 2019/11/29 0031 下午 13:58
 */
@Data
public class TempNotice implements Serializable {
    private Integer id;
    /**
     * 消息推送的类型 1--极光推送;2--app自定义消息
     */
    private String pushType;
    /**
     * 极光推送的一级标题
     */
    private String noticeTitle;
    /**
     * 极光推送的二级标题
     */
    private String msgTitle;
    /**
     * 极光推送的消息内容
     */
    private String msgContent;
    /**
     * 消息推送的范围 all--全部;alias根据别名推送;
     *              allIos推送所有IOS用户;allAndroid推送所有的Android用户
     */
    private String pushRange;
    /**
     * 消息的创建时间
     */
    private LocalDateTime createTime;

    //以下是app自定义消息的操作字段
    /**
     *  消息跳转方式: 1--消息推送到消息中心界面;2--跳转到指定Web界面  URL要全
     *              3--跳转到指定controller页面;4--APP内的弹框形式公告
     */
    private String extraType;
    /**
     * 跳转到指定URL设置 URL要全
     * 如"http://www.baidu.com"
     */
    private String extraUrl;
    /**
     * 是否是PDF (0-不是;1-是)  extraType = 2 时 且配合Url才有效
     */
    private String extraIsPDF;
    /**
     * 当extraType = 2 时 该字段为URL界面的标题名
     * 当extraType = 4 时 该字段为公告的内容
     */
    private String extraParams;
    /**
     * 跳转到指定Ios的controller界面
     */
    private String extraControllerIOS;
    /**
     * 跳转到指定Android的controller界面
     */
    private String extraControllerAndroid;
    /**
     * 消息的声音
     */
    private String extraSound;
    /**
     * 是否跳转(0-不跳转;1-跳转到消息管理;2-跳转到URL;3-跳转到Controller;4-跳转下一个公告)
     */
    private String extraOperationType;
}
