package com.parksong.beans.sms;

import com.parksong.beans.delivery.Delivery;
import com.parksong.beans.delivery.DeliveryStatus;
import com.parksong.beans.express.ExpressType;
import com.parksong.beans.store.StoreShelf;
import com.parksong.util.enums.SMSErrorCodeEnum;
import lombok.Builder;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 派件信息，包括：
 * 基础信息，货架信息，状态信息，快递信息，短信状态，备注信息，滞留天数
 * @author liutianyuan
 *
 */
@Data
@Builder
public class DeliveryDto{

	private Delivery delivery;
	private List<DeliveryStatus> status;
	private StoreShelf shelf;
	private ExpressType express;
	private int strandedDay;
	private int strandedSmsAgain;//滞留件是否当天是否重发短信
	private TypeLibrary typeLibrary;
	private int smsStatus = -1;
	private String bussCode;
	private String resultInfo;//短信失败原因

	private Integer sendSuccessType;//短信通道类型(1.短信发送 2.微信发送 3.短信,微信都发送')

	//排序用 时间
	private Date sortTime;

	public String getFailReason() {
    	return SMSErrorCodeEnum.of(this.resultInfo);
    }
}
