package com.parksong.controllers.app;

import com.alibaba.fastjson.JSONObject;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.beans.app.OssTokenBean;
import com.parksong.beans.app.OssTokenRequestBean;
import com.parksong.filter.app.AppFilter;
import com.parksong.services.app.AppService;
import com.parksong.util.Http.OkHttpUtil;
import com.parksong.util.enums.OssEnum;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author LiuJS
 * @Time 2021/5/27 10:52
 * @Desc app版本
 * @Version 1.0
 */
@Slf4j
@RestController
@RequestMapping("app")
public class AppController {

    @Autowired
    private AppService appService;

    @PostMapping("check")
    public ResultBean check(@RequestBody ApiFilter<AppFilter> apiFilter) {
        return new ResultBean(appService.checkVersion(apiFilter.getData()));
    }

    /**
     * APP获取OSS临时token接口
     * @return
     * @throws Exception
     */
    @GetMapping("/ossSecurityToken")
    public Object ossSecurityToken() throws Exception{
        OssTokenRequestBean ossTokenRequestBean = new OssTokenRequestBean();
        ossTokenRequestBean.setAccessKeyId(OssEnum.ACCESS_KEY_ID.getValue());
        ossTokenRequestBean.setAccessKeySecret(OssEnum.ACCESS_KEY_SECRET.getValue());
        ossTokenRequestBean.setRoleArn(OssEnum.ROLE_ARN.getValue());
        ossTokenRequestBean.setPolicy(OssEnum.POLICY.getValue());
        ossTokenRequestBean.setDurationSeconds(900L);
        ossTokenRequestBean.setRoleSessionName("youbaimi");
        String url = "http://ybmcp.uxskj.com";
        String res = OkHttpUtil.postJson(url + "/logistics/alibb/ossSecurityToken", ossTokenRequestBean);
        log.info("APP获取OSS临时token接口返回参数：{}",res);
        OssTokenBean ossTokenBean = JSONObject.parseObject(res, OssTokenBean.class);
        ResultBean resultBean = new ResultBean(ossTokenBean);
        return resultBean;
    }
}
