package com.parksong.controllers.enums;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.beans.enums.EnumsData;
import com.parksong.filter.enums.EnumsFilter;
import com.parksong.services.enums.EnumsStatusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.lang.reflect.InvocationTargetException;
import java.util.List;

/**
 * @ClassName EnumsControllers
 * @Description TODO
 * @Author Administrator
 * @Date 2019/9/11 0011 上午 9:34
 * @Version 1.0
 **/
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/type")
public class EnumsController {

    @Autowired
    private EnumsStatusService enumsStatusService;

    /**
     * 获取签收回传状态
     * @param filter
     * @return
     * @throws ClassNotFoundException
     * @throws NoSuchMethodException
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     */
    @RequestMapping(value ="/app/getType", method = {RequestMethod.POST})
    @ResponseBody
    @ApiVersion(1)
    public ResultBean<List<EnumsData>> getType(@RequestBody ApiFilter<EnumsFilter> filter) throws ClassNotFoundException, NoSuchMethodException, IllegalAccessException, InvocationTargetException {
        return new ResultBean<List<EnumsData>>(enumsStatusService.getType(filter.getData().getType()));
    }
}
