package com.parksong.controllers.express;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.BatchDataMsg;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.beans.express.ExpressDeptAccount;
import com.parksong.filter.delivery.DeliveryFilter;
import com.parksong.filter.express.ExpressFilter;
import com.parksong.services.express.ExpressDeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 〈功能概述〉<br>
 *
 * @className: ExpressDept
 * @package: com.parksong.controllers.express
 * @author: kael
 * @date: 2019/12/4 0004 下午 15:11
 */
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/express")
public class ExpressDeptController {

    @Autowired
    private ExpressDeptService expressDeptService;

    /**
     * 获取
     * @param filter
     * @return
     */
    @RequestMapping(value ="/app/getBalance", method = {RequestMethod.POST})
    @ResponseBody
    @ApiVersion(1)
    public ResultBean<List<ExpressDeptAccount>> getBalance(@RequestBody ApiFilter<ExpressFilter> filter){
        return new ResultBean<>(expressDeptService.getBalanceByStoreId(filter.getData().getStoreId()));
    }
}
