package com.parksong.controllers.message;

import com.alibaba.fastjson.JSON;
import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.basics.util.basic.Pager;
import com.parksong.beans.message.JiguangBean;
import com.parksong.beans.message.TempNotice;
import com.parksong.filter.message.TempNoticeFilter;
import com.parksong.services.message.MessageService;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 消息管理<br>
 *
 * @className: messageController
 * @package: com.parksong.controllers.message
 * @author: liujs
 * @date: 2019/11/29 0006 上午 11:01
 */
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/message")
public class MessageController {

    @Resource
    private MessageService messageService;

    @RequestMapping(value ="/app/list", method = {RequestMethod.POST})
    public ResultBean<Pager<JiguangBean>> getNotice(@RequestBody ApiFilter<TempNoticeFilter> filter){
        return new ResultBean<>(messageService.getNotice(filter.getData()));
    }
}
