package com.parksong.controllers.sms;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.BatchDataMsg;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.filter.sms.SmsFilter;
import com.parksong.services.sms.SmsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @ClassName SmsController
 * @Description 短信
 * @Author kael
 * @Date 2019/9/27 0027 下午 18:03
 * @Version 1.0
 **/
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/sms")
public class SmsController {

    @Autowired
    private SmsService smsService;

    /**
     * 签收回传通过id
     * @param filter
     * @return
     */
    @RequestMapping(value ="/app/sendSms", method = {RequestMethod.POST})
    @ResponseBody
    @ApiVersion(1)
    public ResultBean<List<BatchDataMsg>> sendSms(@RequestBody ApiFilter<SmsFilter> filter){
        return new ResultBean<List<BatchDataMsg>>(smsService.batchSendSms(filter.getData()));
    }
}
