package com.parksong.controllers.store;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.beans.delivery.Delivery;
import com.parksong.beans.store.PickupQueue;
import com.parksong.filter.store.PickupQueueFilter;
import com.parksong.services.store.PickupQueueService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 排队<br>
 *
 * @className: pickupQueueController
 * @package: com.parksong.controllers.store
 * @author: kael
 * @date: 2019/11/6 0006 上午 11:01
 */
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/pickupQueue")
public class PickupQueueController {

    @Autowired
    private PickupQueueService pickupQueueService;

    /**
     * 获取所有列表
     */
    @RequestMapping(value = "/app/list",method = {RequestMethod.POST})
    public ResultBean<List<PickupQueue>> getList(@RequestBody ApiFilter<PickupQueueFilter> filter){
        return new ResultBean<List<PickupQueue>>(pickupQueueService.getList(filter.getData()));
    }

    /**
     * 锁定
     */
    @RequestMapping(value = "/app/locking",method = {RequestMethod.POST})
    public ResultBean<List<String>> locking(@RequestBody ApiFilter<PickupQueueFilter> filter){
        return new ResultBean<List<String>>(pickupQueueService.locking(filter.getData()));
    }

    /**
     * 订单数据
     */
    @RequestMapping(value = "/app/delivers",method = {RequestMethod.POST})
    public ResultBean<List<Delivery>> delivers(@RequestBody ApiFilter<PickupQueueFilter> filter){
        return new ResultBean<List<Delivery>>(pickupQueueService.delivers(filter.getData()));
    }

    /**
     * 订单数据
     */
    @RequestMapping(value = "/app/delete",method = {RequestMethod.POST})
    public ResultBean<Boolean> delete(@RequestBody ApiFilter<PickupQueueFilter> filter){
        return new ResultBean<Boolean>(pickupQueueService.delete(filter.getData()));
    }
}
