package com.parksong.controllers.store;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.filter.store.StoreFilter;
import com.parksong.services.store.StoreService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author LiuJS
 * @Time 2021/6/30 10:10
 * @Desc
 * @Version 1.0
 */
@RestController
@ApiVersion(2)
@RequestMapping("/{version}/store")
public class StoreController {

    @Autowired
    private StoreService storeService;

    @PostMapping("/consigneePhoneInfo")
    public ResultBean<List<String>> consigneePhoneInfo(@RequestBody ApiFilter<StoreFilter> filter){
        return new ResultBean<>(storeService.getConsigneePhoneInfo(filter.getStoreId()));
    }
}
