package com.parksong.controllers.store;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.controllers.BasicsController;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.beans.store.StoreSmsTemplate;
import com.parksong.filter.store.StoreFilter;
import com.parksong.filter.store.StoreSmsTemplateFilter;
import com.parksong.services.store.StoreSmsTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.naming.ldap.BasicControl;
import java.lang.reflect.Method;
import java.util.List;

/**
 * @ClassName
 * @Description
 * @Author liujs
 * @Date 2019/09/20 上午 10:54
 * @Modefy
 * @Version 1.0
 */
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/store")
public class storeSmsTemplateController extends BasicsController {

    @Autowired
    private StoreSmsTemplateService storeSmsTemplateService;

    /**
     * 获取商店短信模板
     */
    @RequestMapping(value = "/app/getStoreSmsTemplate",method = {RequestMethod.POST})
    public ResultBean<List<StoreSmsTemplate>> getStoreSmsTemplate(@RequestBody ApiFilter<StoreSmsTemplateFilter> filter){
        return new ResultBean<List<StoreSmsTemplate>>(storeSmsTemplateService.getStoreSmsTemplate(filter.getData()));
    }

    /**
     * 更新商店使用的短信模板
     */
    @RequestMapping(value = "/app/updateUsedStoreSmsTemplate",method = {RequestMethod.POST})
    public ResultBean<Boolean> updateUsedStoreSmsTemplate(@RequestBody ApiFilter<StoreSmsTemplateFilter> filter){
        return null;
    }
}
