package com.parksong.controllers.user;

import com.parksong.basics.api.ApiVersion;
import com.parksong.basics.api.Limiting;
import com.parksong.basics.beans.PageResultBean;
import com.parksong.basics.beans.ResultBean;
import com.parksong.basics.controllers.BasicsController;
import com.parksong.basics.filter.ApiFilter;
import com.parksong.beans.delivery.Delivery;
import com.parksong.beans.user.LoginData;
import com.parksong.beans.user.User;
import com.parksong.filter.delivery.DeliveryFilter;
import com.parksong.filter.user.UserFilter;
import com.parksong.services.user.UsersService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @ClassName UserController
 * @Description 用户
 * @Author kael
 * @Date 2019/9/20 0020 上午 10:33
 * @Version 1.0
 **/
@RestController
@ApiVersion(1)
@RequestMapping("/{version}/user")
public class UserController extends BasicsController {

    @Autowired
    private UsersService usersService;

    /**
     * 用户登录
     * @param filter
     * @return
     */
    @RequestMapping(value ="/app/login", method = {RequestMethod.POST})
    @ResponseBody
    @ApiVersion(1)
    @Limiting
    public ResultBean<LoginData> querySignReturn(@RequestBody ApiFilter<UserFilter> filter){
        return new ResultBean<LoginData>(usersService.login(filter.getData()));
    }
}
