package com.parksong.dao.store;

import com.parksong.basics.dao.BasicDao;
import com.parksong.beans.store.PickupQueue;
import com.parksong.filter.store.PickupQueueFilter;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 排队<br>
 *
 * @className: PickupQueueDao
 * @package: com.parksong.dao.store
 * @author: kael
 * @date: 2019/11/6 0006 上午 11:09
 */
@Repository
public interface PickupQueueDao  extends BasicDao<PickupQueueFilter, PickupQueue> {
    /**
     * 根据门店获取所有排队信息
     * @param storeId
     * @return
     */
    List<PickupQueue> all(Integer storeId);

    /**
     * 获取前
     * @param filter
     * @return
     */
    List<PickupQueue> getByQty(PickupQueueFilter filter);

    /**
     * 批量更新签收状态
     * @param pickupQueues
     * @return
     */
    Integer updateSignStatus(List<PickupQueue> pickupQueues);

    /**
     * 获取数据，通过电话号码
     * @param phone
     * @return
     */
    PickupQueue getByPhone(String phone);
}
