package com.parksong.dao.store;

import com.parksong.basics.dao.BasicDao;
import com.parksong.beans.store.SignBackSwitchBean;
import com.parksong.beans.store.Store;
import com.parksong.filter.store.StoreFilter;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author kael
 */
@Repository
public interface StoreDao extends BasicDao<StoreFilter, Store> {

    /**
     * 通过id查询门店信息
     * @param storeId
     * @return
     */
    public Store getStoreById(Integer storeId);

    /**
     * 获取门店签收回传信息配置，通过快递id和门店id
     * @param filter
     * @return
     */
    public SignBackSwitchBean getSignBackSwitch(StoreFilter filter);

    List<String> getConsigneePhoneInfo(@Param("storeId") Integer storeId);
}
