package com.parksong.factory.infoplatform;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @ClassName PlatformFactory
 * @Description 简单工厂，只需简单工厂即可实现
 * @Author wsc
 * @Date 2019/11/27 0028 下午 15:47
 * @Version 1.0
 **/
@Component
public class InfoPlatformFactory {

    @Autowired
    private Map<String, BaseInfoPlatform> context = new ConcurrentHashMap<>();

    public BaseInfoPlatform getPlatform(String platform){
        if(platform == null){
            return null;
        }
        return this.context.get(platform);
    }
}
