package com.parksong.factory.infoplatform.realize;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.common.base.Strings;
import com.parksong.beans.delivery.GetInfoByExpCodeBean;
import com.parksong.beans.expparam.StGetPhoneParam;
import com.parksong.beans.express.ExpressType;
import com.parksong.factory.infoplatform.BaseInfoPlatform;
import com.parksong.filter.delivery.DeliveryFilter;
import com.parksong.services.store.ConfigurationService;
import com.parksong.util.Http.OkHttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Optional;
import java.util.UUID;

/**
 * @ClassName WuXiPlatform
 * @Description 无锡短信
 * @Author wsc
 * @Date 2019/11/27 0027 下午 15:09
 * @Version 1.0
 **/
@Component("272")
@Slf4j
public class StoPlatform implements BaseInfoPlatform {
    @Autowired
    private ConfigurationService configurationService;

    @Override
    public GetInfoByExpCodeBean getInfoByExpCode(DeliveryFilter filter) {
        return shentongGetPhone(filter.getExpCode());
    }

    @Override
    public ExpressType getExpressByExpCode(String expCode) {
        return null;
    }

    public GetInfoByExpCodeBean shentongGetPhone(String expCode) {
        String url = configurationService.getConfigurationByCode("shentongGetPhoneUrl").getOValue1();
//        String url="http://localhost:8089/logistics/shentongGetPhone";
        StGetPhoneParam stGetPhoneParam = new StGetPhoneParam();
        stGetPhoneParam.setAppid(configurationService.getConfigurationByCode("shentongGetPhoneAppId").getOValue1());
        stGetPhoneParam.setKey(configurationService.getConfigurationByCode("shentongGetPhoneKey").getOValue1());
        stGetPhoneParam.setWaybillNo(expCode);
        stGetPhoneParam.setTimestamp(System.currentTimeMillis() + "");
        stGetPhoneParam.setNonce(UUID.randomUUID().toString());
        GetInfoByExpCodeBean expCodeBean = null;
        try {
            String res = OkHttpUtil.postJson(url, stGetPhoneParam);
            JSONObject jsonObject = JSON.parseObject(res);
            String consigneePhone = null;
            if (jsonObject != null && !Strings.isNullOrEmpty((consigneePhone = jsonObject.getString("consigneePhone")))) {
                expCodeBean = GetInfoByExpCodeBean.builder().telPhone(consigneePhone).platform("STO").build();
            }
        } catch (Exception e) {
            log.error(e.toString());
        }
        return expCodeBean;
    }
}
