package com.parksong.filter.delivery;

import com.parksong.basics.filter.Filter;
import lombok.*;

import java.util.List;

/**
 * @ClassName DeliveryFilter
 * @Description TODO
 * @Author kael
 * @Date 2019/9/6 0006 下午 14:57
 * @Version 1.0
 **/
@EqualsAndHashCode(callSuper = true)
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class DeliveryFilter extends Filter {
    /**
     * 快递公司id
     */
    private Integer expId;
    /**
     * 门店id
     */
    private Integer storeId;
    /**
     * 回传状态
     */
    private Integer returnStatus;
    /**
     * 业务表id集合
     */
    private List<Integer> deliveryIds;

    /**
     * 订单号集合
     */
    private List<String> expCodes;

    /**
     * 业务表id
     */
    private Integer deliveryId;
    /**
     * 入库类
     */
    private List<StorageDeliveryFilter> deliverys;
    /**
     * 查询入库开始时间
     */
    private String beginTime;
    /**
     * 查询入库结束时间
     */
    private String endTime;
    /**
     * 快件状态, ALL/INSTORE NOTSIGN未签收
     */
    private String type;

    private String shelfId;
    /**
     * 通知类型短信或者微信
     */
    private Integer smsType;
    /**
     * 通知状态
     */
    private Integer smsStatus;
    /**
     * 查询输入参数
     */
    private String input;
    /**
     * 查询类型(运单号/手机号/取件码),1面单号 2手机号 3取货码 4姓名
     */
    private Integer queryType;
    /**
     * 0的时候快件查询
     */
    private String search;
    /**
     * 页面访问类型,
     */
    private String pageType;

    /**
     * 状态集合
     */
    private List<Integer> statusList;

    private String expCode;

    private String revexpCode;

    private String userPhone;

    private String revuserPhone;

    private String shelfCode;

    private String userName;

    private Boolean whiteUser;
    /**
     * 平台
     */
    private String platform;
    /**
     * 订单状态
     */
    private Integer statusType;

    private List<String> phones;
    /**
     * 用于判断是否排队页面，如果是则计算用户
     */
    private Integer isPickup;
    /**
     * 用于是否开启签收联想功能
     */
    private Boolean isSignAssociation;
    /**
     * 签收联想快递搜索时间
     */
    private String searchExpTime;

    private String timeConditions;
    /**
     * 签收时的图片
     */
    private List<String> expSignPhotos;
    /**
     * 小区id
     */
    private Integer areaId;
    /**
     * 收件人名称
     */
    private String consingeeName;
    /**
     * 收件人号码
     */
    private String consigneePhone;
    /**
     * 收件人电话号码后四位
     */
    private String consigneePhoneEnd;
    /**
     * 收件人地址
     */
    private String address;
    /**
     * 楼栋号
     */
    private String buildingNumber;
    /**
     * 楼层号
     */
    private String floorNumber;
    /**
     * 备注
     */
    private String remark;

    //---------------------寄件信息--------------------
    /**
     * 寄件人姓名
     */
    private String senderName;
    /**
     * 寄件人电话
     */
    private String senderPhone;
}
