package com.parksong.job;

import com.parksong.beans.delivery.BaseStatToday;
import com.parksong.services.delivery.DeliverysService;
import lombok.extern.slf4j.Slf4j;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @ClassName ScheduledJob
 * @Description 定时任务
 * @Author kael
 * @Date 2019/10/11 0011 上午 10:21
 * @Version 1.0
 **/
@Component
@Slf4j
public class ScheduledJob {

    @Autowired
    private DeliverysService deliverysService;
    /**
     * 凌晨将所有统计数据推到昨天
     */
    @Scheduled(cron = "0 0 0 * * ?")
    public void pushBaseStatTodayToYesterday() {
        log.info("【开始执行数据统计定时任务，执行时间】：{} ",new DateTime(new Date()).toString("yyyy-MM-dd HH:mm:ss"));
        BaseStatToday statToday = new BaseStatToday();
        deliverysService.pushTodayToYesterday(statToday);
        log.info("【数据统计定时任务结束，结束时间】：{} ",new DateTime(new Date()).toString("yyyy-MM-dd HH:mm:ss"));
    }
}
