package com.parksong.services.config.impl;

import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.config.PlatformConfig;
import com.parksong.dao.config.PlatformConfigDao;
import com.parksong.services.config.PlatformConfigService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author kael
 */
@Service
@Slf4j
public class PlatformConfigServiceImpl implements PlatformConfigService {

	@Autowired
	private PlatformConfigDao platformConfigDao;

	/**
	 * 通过平台查询配置信息
	 * @param platform
	 * @return
	 */
	@Override
	public PlatformConfig getByPlatform(String platform){
		CacheTool cacheTool = CacheTool.initPlatformConfig();
		PlatformConfig platformConfig = (PlatformConfig) cacheTool.getBean(platform);
		if (platformConfig != null) {
			return platformConfig;
		} else {
			platformConfig = platformConfigDao.getByPlatform(platform);
			if (platformConfig != null) {
				cacheTool.saveBean(platform, platformConfig);
				return platformConfig;
			}
			return null;
		}
	}
}
