package com.parksong.services.delivery;

import com.parksong.beans.delivery.BaseStatToday;
import com.parksong.beans.delivery.Delivery;
import com.parksong.beans.delivery.DeliveryScanBatch;
import com.parksong.beans.delivery.DeliveryStatus;

import java.util.concurrent.CompletableFuture;

/**
 * 业务表使用线程池处理的方法
 * @author kael
 */
public interface DeliveryAsyncService {
    /**
     * 插入总表
     * @param delivery
     * @return
     */
    CompletableFuture<Integer> insertTotalDelivery(Delivery delivery);

    /**
     * 修改总表
     * @param delivery
     * @return
     */
    Integer updateDeliveryToday(Delivery delivery);

    /**
     * 插入总表
     * @param deliveryStatus
     * @return
     */
    Integer insertTotalDeliveryStatus(DeliveryStatus deliveryStatus);

    /**
     * 每天定时统计任务
     * @param baseStatToday
     * @return
     */
    Integer pushTodayToYesterday(BaseStatToday baseStatToday);

    /**
     * 插入总表
     * @param deliveryScanBatch
     * @return
     */
    Integer insertTotalDeliveryScanBatch(DeliveryScanBatch deliveryScanBatch);

    CompletableFuture<Integer> updateMasterDelivery(Delivery entity, Delivery delivery);
}
