package com.parksong.services.express.impl;

import com.parksong.basics.services.BasicsService;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.express.ExpressDeptAccount;
import com.parksong.dao.express.ExpressDeptAccountDao;
import com.parksong.services.express.ExpressDeptAccountService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ExpressAccountServiceImpl.java
 * @Description TODO
 * @createTime 2019年11月27日 16:43:00
 */
@Service
public class ExpressDeptAccountServiceImpl extends BasicsService implements ExpressDeptAccountService {
    @Autowired
    private ExpressDeptAccountDao accountDao;

    @Override
    public ExpressDeptAccount getAccount(Integer storeId, Integer expId) {
        CacheTool cacheTool = CacheTool.initExpressAccountTool();
        ExpressDeptAccount account = (ExpressDeptAccount) cacheTool.getBean(storeId.toString() + expId);
        if (null == account) {
            account = accountDao.selectAccountForCache(storeId, expId);
            if (null == account) {
                account = new ExpressDeptAccount();
            }
            cacheTool.saveBean(generatorRedisKey(account.getStoreId(), account.getExpId()), account);
        }
        return null == account.getId() ? null : account;
    }

    public String generatorRedisKey(Long storeId, Long expId) {
        return new StringBuilder().append(storeId).append("_").append(expId).toString();
    }
}
