package com.parksong.services.express.impl;

import com.alibaba.fastjson.JSON;
import com.parksong.basics.services.BasicsService;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.express.ExpressRule;
import com.parksong.beans.express.ExpressType;
import com.parksong.dao.express.ExpressDao;
import com.parksong.services.express.ExpressService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName ExpressServiceImpl
 * @Description TODO
 * @Author kael
 * @Date 2019/9/20 0020 下午 14:43
 * @Version 1.0
 **/
@Service
public class ExpressServiceImpl extends BasicsService implements ExpressService {

    @Autowired
    private ExpressDao expressDao;

    @Override
    public List<ExpressRule> allExpressRule(){

        CacheTool cacheTool = CacheTool.initExpressRule();
        List<ExpressRule> list = (List<ExpressRule>) cacheTool.getBean(0 + "", ExpressRule.class);

        if(null != list && list.size() > 0){
            return list;
        }
        list=expressDao.allExpressRule();
        if (list!=null&&list.size()>0) {
            for(ExpressRule expressRule :list){
                cacheTool.saveBean(expressRule.getExpId().toString(), expressRule);
            }
        }else{
            list = new ArrayList<>();
        }
        return list;
    }

    @Override
    public Map<Integer,ExpressRule> allExpressRuleMap(){
        List<ExpressRule> list = this.allExpressRule();
        Map<Integer,ExpressRule> map = new HashMap<>(16);
        for (ExpressRule expressRule : list) {
            map.put(expressRule.getId(),expressRule);
        }
        return map;
    }

    @Override
    public ExpressType getExpressById(Integer expressId) {
        CacheTool cacheTool = CacheTool.initExpress();
        ExpressType express = (ExpressType) cacheTool.getBean(expressId + "");
        if(null == express) {
            List<ExpressType> allExpress = getAllExpress();
            if(null != allExpress && allExpress.size() > 0){
                for (ExpressType item : allExpress){
                    if(item.getExpId().equals(expressId)){
                        cacheTool.saveBean(String.valueOf(item.getExpId()), JSON.toJSON(item));
                        express = item;
                        break;
                    }
                }
            }
        }
        return express;
    }

    public List<ExpressType> getAllExpress(){
        CacheTool cacheTool = CacheTool.initExpress();
        List<ExpressType> expressTypes = cacheTool.getBean("0", ExpressType.class);
        if(null != expressTypes && expressTypes.size()>0){
            return expressTypes;
        }
        // TODO 将从数据库获取的数据存入Redis中
        return expressDao.getAllExpress();
    }
}
