package com.parksong.services.log.impl;

import com.parksong.beans.log.LoggingEvent;
import com.parksong.dao.log.LoggingEventDao;
import com.parksong.services.log.LoggingEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * @ClassName LoggingEventServiceImpl
 * @Description 日志类
 * @Author kael
 * @Date 2019/9/10 0010 下午 14:50
 * @Version 1.0
 **/
@Service
public class LoggingEventServiceImpl implements LoggingEventService {

    @Autowired
    private LoggingEventDao loggingEventDao;

    @Override
    public Integer addLog(String requestMsg, String responseMsg, String userId, Integer storeId, Integer code, String type, Integer exTime) {
        LoggingEvent loggingEvent = LoggingEvent.builder()
                .requestMsg(this.strToString(requestMsg,500))
                .responseMsg(this.strToString(responseMsg,500))
                .userId(userId)
                .storeId(storeId)
                .returnCode(code)
                .type(type)
                .exTime(exTime)
                .build();
        loggingEvent.setCreateTime(new Date());
        return loggingEventDao.insert(loggingEvent);
    }

    @Override
    public Integer addLog(String requestMsg,String responseMsg, Integer code, Integer exTime) {

        return this.addLog(requestMsg,responseMsg,"",null,code,"error",exTime);
    }

    private String strToString(String msg,Integer num){
        if(msg!=null && msg.length()>num){
            return msg.substring(0,num-1);
        }
        return msg;
    }
}
