package com.parksong.services.message.impl;

import com.parksong.basics.util.basic.Pager;
import com.parksong.beans.message.ExtraBean;
import com.parksong.beans.message.JiguangBean;
import com.parksong.beans.message.TempNotice;
import com.parksong.dao.message.TempNoticeDao;
import com.parksong.filter.message.TempNoticeFilter;
import com.parksong.services.message.MessageService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;

/**
 * 消息管理<br>
 *
 * @className: messageServiceImpl
 * @author: liujs
 * @date: 2019/11/29 0006 上午 11:01
 */
@Service
public class MessageServiceImpl implements MessageService {

    @Resource
    private TempNoticeDao tempNoticeDao;

    @Override
    public Integer getListCount(TempNoticeFilter filter) {
        return tempNoticeDao.getListCount(filter);
    }

    @Override
    public Pager<JiguangBean> getNotice(TempNoticeFilter filter) {
        filter.init();
        Pager<JiguangBean> pager = new Pager<>(getListCount(filter), filter.getCurrentPage(),filter.getPageSize());
        pager.setList(getMessageManagement(filter));
        return pager;
    }

    public List<JiguangBean> getMessageManagement(TempNoticeFilter filter) {
        filter.sortInit();
        List<TempNotice> tempNoticeList = tempNoticeDao.getMessageManagement(filter);
        List<JiguangBean> jiguangBeanList = new ArrayList<>();
        tempNoticeList.forEach(tempNotice -> jiguangBeanList.add(dealWithData(tempNotice)));
        return jiguangBeanList;
    }

    private JiguangBean dealWithData(TempNotice tempNotice) {
        JiguangBean jiguangBean = new JiguangBean();
        ExtraBean extraBean = new ExtraBean();
        jiguangBean.setPushType(tempNotice.getPushType());
        jiguangBean.setNotification_title(tempNotice.getNoticeTitle());
        jiguangBean.setMsg_title(tempNotice.getMsgTitle());
        jiguangBean.setMsg_content(tempNotice.getMsgContent());
        jiguangBean.setPushRange(tempNotice.getPushRange());
        jiguangBean.setCreateTime(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss").format(tempNotice.getCreateTime()));
        extraBean.setType(tempNotice.getExtraType());
        extraBean.setUrl(tempNotice.getExtraUrl());
        extraBean.setIsPDF(tempNotice.getExtraIsPDF());
        extraBean.setControllerIOS(tempNotice.getExtraControllerIOS());
        extraBean.setControllerAndroid(tempNotice.getExtraControllerAndroid());
        extraBean.setSound(tempNotice.getExtraSound());
        extraBean.setParams(tempNotice.getExtraParams());
        extraBean.setOperationType(tempNotice.getExtraOperationType());
        jiguangBean.setExtraBean(extraBean);
        return jiguangBean;
    }
}
