package com.parksong.services.store;

import com.parksong.beans.delivery.Delivery;
import com.parksong.beans.store.PickupQueue;
import com.parksong.filter.store.PickupQueueFilter;

import java.util.List;
import java.util.Map;

/**
 * 排队<br>
 *
 * @className: PickupQueueService
 * @package: com.parksong.services.store
 * @author: kael
 * @date: 2019/11/6 0006 上午 11:05
 */
public interface PickupQueueService {
    /**
     * 获取所有排队数据
     * @param filter
     * @return
     */
    List<PickupQueue> getList(PickupQueueFilter filter);

    /**
     * 锁定用户
     * @param filter
     * @return
     */
    List<String> locking(PickupQueueFilter filter);

    /**
     * 获取订单
     * @param filter
     * @return
     */
    List<Delivery> delivers(PickupQueueFilter filter);

    /**
     * 出库增加数量
     * @param pickup
     * @return
     */
    boolean pickupSign(Map<String, Integer> pickup);

    /**
     * 通过id批量删除
     * @param filter
     * @return
     */
    boolean delete(PickupQueueFilter filter);
}
