package com.parksong.services.store.impl;

import com.parksong.basics.services.BasicsService;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.store.Configuration;
import com.parksong.dao.store.ConfigurationDao;
import com.parksong.services.store.ConfigurationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * @ClassName ConfigUrationServiceImpl
 * @Description TODO
 * @Author kael
 * @Date 2019/9/16 0016 上午 9:58
 * @Version 1.0
 **/
@Service
public class ConfigurationServiceImpl extends BasicsService implements ConfigurationService {

    @Autowired
    public ConfigurationDao configurationDao;

    @Override
    public Configuration getConfigurationByCode(String code){
        CacheTool cacheTool = CacheTool.initConfiguration();
        Configuration configurationByRedis = (Configuration) cacheTool.getBean(code);
        if (configurationByRedis != null) {
            return configurationByRedis;
        } else {

            Configuration configurationBySql = configurationDao.getConfigurationByCode(code);
            if (configurationBySql != null) {
                cacheTool.saveBean(code, configurationBySql);
                return configurationBySql;
            }
            return null;
        }
    }

}
