package com.parksong.services.store.impl;

import com.parksong.basics.services.BasicsService;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.store.SignBackSwitchBean;
import com.parksong.beans.store.Store;
import com.parksong.dao.store.StoreDao;
import com.parksong.filter.store.StoreFilter;
import com.parksong.services.store.StoreService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @ClassName StoreServiceImpl
 * @Description 门店
 * @Author kael
 * @Date 2019/9/11 0011 下午 17:36
 * @Version 1.0
 **/
@Service
public class StoreServiceImpl extends BasicsService implements StoreService {

    @Autowired
    private StoreDao storeDao;

    @Override
    public Store getStoreById(Integer storeId){
        CacheTool cacheTool = CacheTool.initStore();
        Store store = (Store) cacheTool.getBean(storeId + "");
        if (store != null) {
            return store;
        } else {
            Store store1 = storeDao.getStoreById(storeId);
            if (store1 != null) {
                cacheTool.saveBean(storeId + "", store1);
                return store1;
            }
            return null;
        }
    }

    @Override
    public SignBackSwitchBean getSignBackSwitch(Integer expId, Integer storeId) {
        StoreFilter filter = StoreFilter.builder()
                .expId(expId).build();
        filter.setStoreId(storeId);
        return storeDao.getSignBackSwitch(filter);
    }

    @Override
    public List<String> getConsigneePhoneInfo(Integer storeId) {
        return storeDao.getConsigneePhoneInfo(storeId);
    }
}
