package com.parksong.services.store.impl;

import com.parksong.basics.services.BasicsService;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.store.StoreShelf;
import com.parksong.dao.store.StoreShelfDao;
import com.parksong.services.store.StoreShelfService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName StoreShelfServiceImpl
 * @Description 货架
 * @Author kael
 * @Date 2019/9/16 0016 上午 10:43
 * @Version 1.0
 **/
@Service
public class StoreShelfServiceImpl extends BasicsService implements StoreShelfService {

    @Autowired
    private StoreShelfDao storeShelfDao;

    @Override
    public StoreShelf getById(Integer shelfId){
        CacheTool cacheTool = CacheTool.initShelf();
        StoreShelf shelf = (StoreShelf)cacheTool.getBean(shelfId + "");
        if(shelf != null){
            return shelf;
        }else{
            shelf = storeShelfDao.getById(shelfId);

            if(shelf != null){
                cacheTool.saveBean(shelfId + "", shelf);
                return shelf;
            }
            return null;
        }
    }
}
