package com.parksong.services.store.impl;

import com.parksong.basics.services.BasicsService;
import com.parksong.basics.util.redis.CacheTool;
import com.parksong.beans.store.StoreSmsTemplate;
import com.parksong.dao.store.StoreSmsTemplateDao;
import com.parksong.filter.store.StoreSmsTemplateFilter;
import com.parksong.services.store.StoreSmsTemplateService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName
 * @Description
 * @Author liujs
 * @Date 2019/09/20 上午 11:00
 * @Modefy
 * @Version 1.0
 */
@Service
@Slf4j
public class StoreSmsTemplateServiceImpl extends BasicsService implements StoreSmsTemplateService {

    @Autowired
    private StoreSmsTemplateDao storeSmsTemplateDao;
    @Override
    public List<StoreSmsTemplate> getStoreSmsTemplate(StoreSmsTemplateFilter filter) {
        List<StoreSmsTemplate> storeSmsTemplateList = new ArrayList<StoreSmsTemplate>();
        log.info("liujs----->: start query data,param: storeId ="+filter.getStoreId());
        storeSmsTemplateList = this.upStoreSmsTemplateCache(filter);
        log.info("liujs----->: complete query data,return Data:count="+storeSmsTemplateList.size());
        return storeSmsTemplateList;
    }

    /*
        实现逻辑:先将该门店所有的模板修改成未使用(先查看是否存在该模板),之后再修改需要使用的模板
     */
    @Override
    public Boolean updateUsedStoreSmsTemplate(StoreSmsTemplateFilter filter) {
        return null;
    }

    private List<StoreSmsTemplate> upStoreSmsTemplateCache(StoreSmsTemplateFilter filter) {
        CacheTool cacheTool = CacheTool.initStoreModel();
        List<StoreSmsTemplate> storeSmsTemplateList = (List<StoreSmsTemplate>)cacheTool.getBean(filter.getStoreId().toString(),StoreSmsTemplate.class);
        if(storeSmsTemplateList==null||storeSmsTemplateList.isEmpty()){
            storeSmsTemplateList = storeSmsTemplateDao.getStoreSmsTemplateByStoreId(filter);
            if(storeSmsTemplateList==null){
                storeSmsTemplateList = new ArrayList<>();
            }
            cacheTool.saveBean(filter.getStoreId().toString(),storeSmsTemplateList);
        }
        return storeSmsTemplateList;
    }
}
