package com.parksong.services.store.impl;

import com.parksong.basics.services.BasicsService;
import com.parksong.beans.store.WhiteList;
import com.parksong.dao.store.WhiteListDao;
import com.parksong.services.store.WhiteListService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName WhiteListServiceImpl
 * @Description TODO
 * @Author kael
 * @Date 2019/9/16 0016 上午 9:32
 * @Version 1.0
 **/
@Service
public class WhiteListServiceImpl extends BasicsService implements WhiteListService {

    @Autowired
    private WhiteListDao whiteListDao;

    @Override
    public List<WhiteList> getByStoreId(Integer storeId){
        return whiteListDao.getByStoreId(storeId);
    }

    @Override
    public Map<Integer,List<WhiteList>> getMapByStoreId(Integer storeId){
        Map<Integer,List<WhiteList>> map = new HashMap<>(2);
        map.put(storeId,this.getByStoreId(storeId));
        return map;
    }

    @Override
    public Map<String,WhiteList> getPhoneMapByStoreId(Integer storeId){
        List<WhiteList> whiteLists = this.getByStoreId(storeId);
        Map map = new HashMap(16);
        for(WhiteList white : whiteLists){
            map.put(white.getUsermobile() , white);
        }
        return map;
    }
}
