package com.parksong.util.enums;

import com.parksong.beans.enums.EnumsData;

import java.util.ArrayList;
import java.util.List;

/**
 * 订单签收回传状态
 * @author kael
 */

public enum DeliverySignReturnEnum {

    SU_SIGN_FAIL("代签失败", 4),
    SIGN_FAIL("签收失败", 2),
    SU_SIGN_SUCCESS("代签成功", 3),
    SIGN_SUCCESS("签收成功", 1);



    private String value;
    private int key;

    DeliverySignReturnEnum(String value, int key) {
        this.value = value;
        this.key = key;
    }

    public static DeliverySignReturnEnum valueOf(int code) {
        for (DeliverySignReturnEnum statusCode : DeliverySignReturnEnum.values()) {
            if (statusCode.getKey() == code) {
                return statusCode;
            }
        }
        return null;
    }

    public static String of(int code) {
        for (DeliverySignReturnEnum returnCode : DeliverySignReturnEnum.values()) {
            if (returnCode.getKey()==code) {
                return returnCode.getValue();
            }
        }
//		 return code;
        return "";
    }

    public static List<EnumsData> getType(){
        List<EnumsData> list = new ArrayList<EnumsData>();
        for(DeliverySignReturnEnum type : DeliverySignReturnEnum.values()){
            EnumsData enumsData = new EnumsData();
            enumsData.setKey(type.getKey());
            enumsData.setValue(type.getValue());
            list.add(enumsData);
        }
        return list;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int getKey() {
        return key;
    }

    public void setKey(int key) {
        this.key = key;
    }
}
