package com.parksong.util.enums;

import com.parksong.beans.enums.EnumsData;

import java.util.ArrayList;
import java.util.List;

/**
 * 对接的快递公司
 * @author kael
 */

public enum ExpressCompanyEnum {
    EXP_ZT("中通", 187,"ZTO"),
    EXP_STO("申通", 272,"STO"),
    EXP_YD("韵达", 17,"YD"),
    EXP_YT("圆通", 202,"YT"),
    EXP_HT("百世汇通", 223,"BEST");


    private String value;
    private int key;
    private String enValue;

    ExpressCompanyEnum(String value, int key,String enValue) {
        this.value = value;
        this.key = key;
        this.enValue = enValue;
    }

    public static ExpressCompanyEnum valueOf(int code) {
        for (ExpressCompanyEnum statusCode : ExpressCompanyEnum.values()) {
            if (statusCode.getKey() == code) {
                return statusCode;
            }
        }
        return null;
    }

    public static List<EnumsData> getType(){
        List<EnumsData> list = new ArrayList<EnumsData>();
        for(ExpressCompanyEnum type : ExpressCompanyEnum.values()){
            EnumsData enumsData = new EnumsData();
            enumsData.setKey(type.getKey());
            enumsData.setValue(type.getValue());
            list.add(enumsData);
        }
        return list;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int getKey() {
        return key;
    }

    public void setKey(int key) {
        this.key = key;
    }

    public String getEnValue() {
        return enValue;
    }

    public void setEnValue(String enValue) {
        this.enValue = enValue;
    }
}
