package com.parksong.util.enums;



/**
 * 短信错误码
 * @author kael
 */

public enum SMSErrorCodeEnum {
	
	/**      移动        **/
	MK_0012("MK:0012", "空号"),
	MK_0001("MK:0001", "空号"),
	MK_0005("MK:0005", "停机"),
	MI_0029("MI:0029", "无信号或不在服务区"),
	UNDELIV("UNDELIV", "号码状态异常"),
	MI_0024("MI:0024", "关机或停机"),
	MK_0000("MK:0000", "空号"),
	MI_0013("MI:0013", "停机"),
	MN_0001("MN:0001", "空号"),
	EXPIRED("EXPIRED", "接收超时"),
	MK_0010("MK:0010", "停机"),
	
	/**     联通      **/
	LT_1("1", "空号"),
	LT_12("12", "空号"),
	LT_10("10", "无法接通"),
	LT_24("24", "号码状态异常"),
	LT_ERROR_1("Error:1", "空号"),
	LT_ERROR_12("Error:12", "空号"),
	LT_ERROR_10("Error:10", "无法接通"),
	LT_ERROR_24("Error:24", "号码状态异常"),
	
	/**     电信      **/
	DX_601("601", "空号");
	
	private String code;
	private String content;
	
	private SMSErrorCodeEnum(String code, String content) {
		this.code = code;
		this.content = content;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getContent() {
		return content;
	}

	public void setContent(String content) {
		this.content = content;
	}
	
	public static String of(String code) {
		 for (SMSErrorCodeEnum errorCode : SMSErrorCodeEnum.values()) {
		     if (errorCode.getCode().equals(code))
		        return errorCode.getContent();
		 }
//		 return code;
		return "未知原因";
   }
}
